'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: dbtools1.inc,v $
'*
'*  $Revision: 1.9.2.1 $
'*
'*  last change: $Author: msc $ $Date: 2003/09/03 09:36:49 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/**************************************************************************************
'*
'* owner : marc.schwanz@sun.com
'*
'* short description : Helper Routines for Base tests.
'*
'***************************************************************************************
'*
' #1 ImpressPilotOff
' #1 hDrawingWithSelection
' #1 hDrawing
' #1 sMenufunctions
' #1 sAutopilot_Groupelement
' #1 sAutopilot_ListBox
' #1 sAutopilot_ComboBox
' #1 sAutopilot_TableElement
' #1 ExplorerSelect 
' #1 sDeleteDatasource
' #1 sDeleteTable	
' #1 fCreateAdabasDatasource
' #1 fFindTable
' #1 fFindDatasource
'*
'\***********************************************************************************
sub ImpressPilotOff
'/// <u>ImpressPilotOff()</u> ///
'///+ Unchecks the settings for starting Impress with autopilot. ///
  ToolsOptions
   printlog "- Deactivate the autopilot for new Impress docs"
   hToolsOptions ( "Presentation", "General" )
   MitAutopilotStarten.Uncheck
   sleep(1)
   Kontext "OptionenDlg"
  OptionenDlg.OK
end sub

'-------------------------------------------------------------------------
sub hDrawingWithSelection ( xS, yS, xE, yE )
'/// <u>hDrawingWithSelection(x1, y1, x2, y2)</u> ///
'///+ Moving the Mouse in a selected state.
   select case gApplication

      case "CALC"        : Kontext "DocumentCalc"
                            DocumentCalc.MouseDown ( xS, yS )
                            DocumentCalc.MouseMove ( xE, yE )
                            DocumentCalc.MouseUp ( xE, yE )

      case "WRITER"      : Kontext "DocumentWriter"
                            DocumentWriter.MouseDown ( xS, yS )
                            DocumentWriter.MouseMove ( xE, yE )
                            DocumentWriter.MouseUp ( xE, yE )

      case "HTMLDOKUMENT": Kontext "DocumentWriterWeb"
                            DocumentWriterWeb.MouseDown ( xS, yS )
                            DocumentWriterWeb.MouseMove ( xE, yE )
                            DocumentWriterWeb.MouseUp ( xE, yE )

      case "GLOBALDOC"   : Kontext "DocumentMasterDoc"
                            DocumentMasterDoc.MouseDown ( xS, yS )
                            DocumentMasterDoc.MouseMove ( xE, yE )
                            DocumentMasterDoc.MouseUp ( xE, yE )

      case "IMPRESS"	 : Kontext "DocumentImpress"
                            DocumentImpress.MouseDown ( xS, yS )
                            DocumentImpress.MouseMove ( xE, yE )
                            DocumentImpress.MouseUp ( xE, yE )

      case "DRAW"        : Kontext "DocumentDraw"
                            DocumentDraw.MouseDown ( xS, yS )
                            DocumentDraw.MouseMove ( xE, yE )
                            DocumentDraw.MouseUp ( xE, yE )

   end select
end sub

'-------------------------------------------------------------------------
sub hDrawing ( xS, yS, xE, yE )
'/// <u>hDrawing(x1, y1, x2, y2)</u> ///
'///+ Moving the Mouse in a NON selected state.
   select case gApplication

      case "CALC"        : Kontext "DocumentCalc"
                            DocumentCalc.MouseDown ( xS, yS )
                            DocumentCalc.MouseMove ( xE, yE )
                            DocumentCalc.MouseUp ( xE, yE )
                            sleep(1)
                            if DocumentCalc.IsEnabled then DocumentCalc.TypeKeys "<Escape>"

      case "WRITER"      : Kontext "DocumentWriter"
                            DocumentWriter.MouseDown ( xS, yS )
                            DocumentWriter.MouseMove ( xE, yE )
                            DocumentWriter.MouseUp ( xE, yE )
                            sleep(1)
                            if DocumentWriter.IsEnabled then DocumentWriter.TypeKeys "<Escape>"

      case "HTMLDOKUMENT": Kontext "DocumentWriterWeb"
                            DocumentWriterWeb.MouseDown ( xS, yS )
                            DocumentWriterWeb.MouseMove ( xE, yE )
                            DocumentWriterWeb.MouseUp ( xE, yE )
                            sleep(1)
                            if DocumentWriterWeb.IsEnabled then DocumentWriterWeb.TypeKeys "<Escape>"

      case "GLOBALDOC"   : Kontext "DocumentMasterDoc"
                            DocumentMasterDoc.MouseDown ( xS, yS )
                            DocumentMasterDoc.MouseMove ( xE, yE )
                            DocumentMasterDoc.MouseUp ( xE, yE )
                            sleep(1)
                            if DocumentMasterDoc.IsEnabled then DocumentMasterDoc.TypeKeys "<Escape>"

      case "IMPRESS"	 : Kontext "DocumentImpress"
                            DocumentImpress.MouseDown ( xS, yS )
                            DocumentImpress.MouseMove ( xE, yE )
                            DocumentImpress.MouseUp ( xE, yE )
                            sleep(1)
                            if DocumentImpress.IsEnabled then DocumentImpress.TypeKeys "<Escape>"

      case "DRAW"        : Kontext "DocumentDraw"
                            DocumentDraw.MouseDown ( xS, yS )
                            DocumentDraw.MouseMove ( xE, yE )
                            DocumentDraw.MouseUp ( xE, yE )
                            if DocumentDraw.IsEnabled then DocumentDraw.TypeKeys "<Escape>"

   end select
end sub

'-------------------------------------------------------------------------
'/// <u>sMenufunctions(string)</u> ///
'///+ Used for the form toolbox. ///
sub sMenufunctions (WhichItem as string)
 Dim i as integer
 Kontext "TB_Formularfunktionen"
  sleep(3)
  for i = 1 to 20
   if _ControlEigenschaften.IsEnabled then
     _ControlEigenschaften.Click
     i=21
    else
     sleep(1)
     if i >= 20 then warnlog "Button " & WhichItem & " is disabled "
     end if
   next i
  Kontext "ControlPropertiesDialog"
   if ControlPropertiesDialog.Exists(3) then
    ControlPropertiesDialog.Close
   end if

   select case gApplication

      case "CALC"        : Kontext "DocumentCalc"
      case "WRITER"      : Kontext "DocumentWriter"
      case "HTMLDOKUMENT": Kontext "DocumentWriterWeb"
      case "GLOBALDOC"   : Kontext "DocumentMasterDoc"
      case "IMPRESS"	 : Kontext "DocumentImpress"
      case "DRAW"        : Kontext "DocumentDraw"

   end select

  try
     FormatControl
     sleep(1)
    Kontext "ControlPropertiesDialog"
      ControlPropertiesDialog.Close
      printlog WhichItem
   catch
     warnlog "  - Controlfieldproperties " & WhichItem & " from menu not available!"
  endcatch

   select case gApplication

      case "CALC"        : Kontext "DocumentCalc"
                            DocumentCalc.TypeKeys "<DELETE>"

      case "WRITER"      : Kontext "DocumentWriterWeb"
                            DocumentWriterWeb.TypeKeys "<DELETE>"

      case "HTMLDOKUMENT": Kontext "DocumentWriterWeb"
                            DocumentWriterWeb.TypeKeys "<DELETE>"

      case "GLOBALDOC"   : Kontext "DocumentMasterDoc"
                            DocumentMasterDoc.TypeKeys "<DELETE>"

      case "IMPRESS"	 : Kontext "DocumentImpress"
                            DocumentImpress.TypeKeys "<DELETE>"

      case "DRAW"        : Kontext "DocumentDraw"
                            DocumentDraw.TypeKeys "<DELETE>"

   end select

 Kontext "TB_Formularfunktionen"
end sub

'-------------------------------------------------------------------------
sub sAutopilot_Groupelement
'/// <u>sAutopilot_Groupelement()</u> ///
'///+ Additional sub for Autopilot for group element. ///
 Dim i as integer
 Kontext "AutopilotGroupElement"
  AutopilotGroupElement.MouseDown (10,10)
  AutopilotGroupElement.MouseUp (10,10)
 for i = 1 to 40
  if AutopilotGroupElement.Exists(3) then
    i=41
    call Dialogtest(AutopilotGroupElement)
    printlog "  - Autopilot group element: Page 1/5"
   Kontext "TabGroupBoxData"
    call Dialogtest(TabGroupBoxData)
    Names.Settext "Option field 1"
    if AddTo.IsEnabled then
       AddTo.Click
     else
       warnlog "Entry couldn't be overtaken in first window of the group box autopilot!"
       AutopilotGroupElement.Cancel
    end if
    sleep(3)
   Kontext "AutopilotGroupElement"
    if NextButton.IsEnabled then
       NextButton.Click
     else
       warnlog "In first window the 'Next'-button is disabled!"
       AutopilotGroupElement.Cancel
    end if
    sleep(3)
    printlog "  - Autopilot group box: Page 2/5"
   Kontext "TabDefaultFieldSelection"
    call Dialogtest (TabDefaultFieldSelection)
   Kontext "AutopilotGroupElement"
    if NextButton.IsEnabled then
       NextButton.Click
     else
      warnlog "In second window the 'Next'-button is disabled!!"
      AutopilotGroupElement.Cancel
    end if
    sleep(3)
    printlog "  - Autopilot group box: Page 3/5"
   Kontext "TabDatabaseValues"
    call DialogTest(TabDatabaseValues)
   Kontext "AutopilotGroupElement"
    if NextButton.IsEnabled then
       NextButton.Click
     else
       warnlog "In third window the 'Next'-button is disabled!"
      AutopilotGroupElement.Cancel
    end if
    sleep(3)
    printlog "  - Autopilot group box: Page 4/5"
   Kontext "TabDatabaseField"
    call DialogTest(TabDatabaseField)
   Kontext "AutopilotGroupElement"
    if NextButton.IsEnabled then
       NextButton.Click
     else
       warnlog "In fourth window the 'Next'-button is disabled!"
       AutopilotGroupElement.Cancel
       exit sub
    end if
    sleep(3)
    printlog "  - Autopilot group box: Page 5/5"
   Kontext "TabCreateOptionGroup"
    call DialogTest (TabCreateOptionGroup)
   Kontext "AutopilotGroupElement"
    if CreateButton.IsEnabled then
       CreateButton.Click
     else
       warnlog "In fifth window the 'Create'-button is disabled!"
       AutopilotGroupElement.Cancel
    end if
   else
     sleep(2)
     if i >= 40 then warnlog "- Autopilot for Group Box didn't appear!"
  end if
 next i
 sleep(2)
end sub

'-------------------------------------------------------------------------
sub sAutopilot_ListBox
'/// <u>sAutopilot_ListBox()</u> ///
'///+ Additional sub for Autopilot for list box. ///
 Dim k as integer
 Kontext "AutoPilotListComboBox"
  AutoPilotListComboBox.MouseDown(10,10)
  AutoPilotListComboBox.MouseUp(10,10)
  if AutoPilotListComboBox.Exists(3) then
    call Dialogtest(AutoPilotListComboBox)
    printlog "  - Autopilot List/Combo Box: Page 1/4"
   Kontext "TabListBoxData"
    call Dialogtest(TabListBoxData)
    k = DataSource.GetItemCount
    if k <> 0 then
      DataSource.Select(1)
      sleep(1)
      Table.Select(1)
      sleep(3)
     else
       warnlog "In first window the source  listbox is 0!"
       AutopilotListComboBox.Cancel
    end if
   Kontext "AutopilotListComboBox"
    if NextButton.IsEnabled then
       NextButton.Click
     else
       warnlog "In first window the 'Next'-button is disabled!"
       AutopilotListComboBox.Cancel
    end if
    sleep(3)
    printlog "  - Autopilot List/Combo Box: Page 2/4"
   Kontext "TabTableSelection"
    call Dialogtest (TabTableSelection)
    TableSelection.Select(1)
    sleep(3)
   Kontext "AutopilotListComboBox"
    if NextButton.IsEnabled then
       NextButton.Click
     else
      warnlog "In second window the 'Next'-button is disabled!!"
      AutopilotListComboBox.Cancel
    end if
    sleep(3)
    printlog "  - Autopilot List/Combo Box: Page 3/4"
   Kontext "TabFieldSelection"
    call DialogTest(TabFieldSelection)
    ExistingFields.Select(1)
    sleep(3)
   Kontext "AutopilotListComboBox"
    if NextButton.IsEnabled then
       NextButton.Click
     else
       warnlog "In third window the 'Next'-button is disabled!"
      AutopilotListComboBox.Cancel
    end if
    sleep(3)
    printlog "  - Autopilot List/Combo Box: Page 4/4"
   Kontext "TabFieldLink"
    call DialogTest (TabFieldLink)
    ValueTable.Select(1)
    sleep(1)
    ListTable.Select(1)
    sleep(3)
   Kontext "AutopilotListComboBox"
    if CreateButton.IsEnabled then
       CreateButton.Click
     else
       warnlog "In fourth window the 'Create'-button is disabled!"
       AutopilotListComboBox.Cancel
    end if
   else
    warnlog "- Autopilot for List Box didn't appear!"
  end if
 sleep(2)
end sub

'-------------------------------------------------------------------------
sub sAutopilot_ComboBox
'/// <u>sAutopilot_ComboBox()</u> ///
'///+ Additional sub for Autopilot for combo box. ///
 Dim k as integer
 Kontext "AutoPilotListComboBox"
  AutoPilotListComboBox.MouseDown (10,10)
  AutoPilotListComboBox.MouseUp (10,10)
  if AutoPilotListComboBox.Exists(3) then
    call Dialogtest(AutoPilotListComboBox)
    printlog "  - Autopilot List/Combo Box: Page 1/4"
   Kontext "TabListBoxData"
    call Dialogtest(TabListBoxData)
    k = DataSource.GetItemCount
    if k <> 0 then
      DataSource.Select(1)
      sleep(1)
      Table.Select(1)
      sleep(3)
     else
       warnlog "In first window the source  listbox is 0!"
       AutopilotListComboBox.Cancel
    end if
   Kontext "AutopilotListComboBox"
    if NextButton.IsEnabled then
       NextButton.Click
     else
       warnlog "In first window the 'Next'-button is disabled!"
       AutopilotListComboBox.Cancel
    end if
    sleep(3)
    printlog "  - Autopilot List/Combo Box: Page 2/4"
   Kontext "TabTableSelection"
    call Dialogtest (TabTableSelection)
    TableSelection.Select(1)
    sleep(3)
   Kontext "AutopilotListComboBox"
    if NextButton.IsEnabled then
       NextButton.Click
     else
      warnlog "In second window the 'Next'-button is disabled!!"
      AutopilotListComboBox.Cancel
    end if
    sleep(3)
    printlog "  - Autopilot List/Combo Box: Page 3/4"
   Kontext "TabFieldSelection"
    call DialogTest(TabFieldSelection)
    ExistingFields.Select(1)
    sleep(3)
   Kontext "AutopilotListComboBox"
    if NextButton.IsEnabled then
       NextButton.Click
     else
       warnlog "In third window the 'Next'-button is disabled!"
      AutopilotListComboBox.Cancel
    end if
    sleep(3)
    printlog "  - Autopilot List/Combo Box: Page 4/4"
   Kontext "TabDatabaseField"
    call DialogTest (TabDatabaseField)
    sleep(3)
   Kontext "AutopilotListComboBox"
    if CreateButton.IsEnabled then
       CreateButton.Click
     else
       warnlog "In fourth window the 'Create'-button is disabled!"
       AutopilotListComboBox.Cancel
    end if
   else
    warnlog "- Autopilot for Combo Box didn't appear!"
  end if
 sleep(2)
end sub

'-------------------------------------------------------------------------

sub sAutopilot_TableElement
'/// <u>sAutopilot_TableElement()</u> ///
'///+ Additional sub for Autopilot table element. ///
 Dim k as integer
 Kontext "AutopilotTableElement"
  AutopilotTableElement.MouseDown (10,10)
  AutopilotTableElement.MouseUp (10,10)
  if AutopilotTableElement.Exists(3) then
    call Dialogtest(AutopilotTableElement)
    printlog "  - Autopilot Table Element: Page 1/2"
   Kontext "TabListBoxData"
    call Dialogtest(TabListBoxData)
    k = DataSource.GetItemCount
    if k <> 0 then
      DataSource.Select(1)
      sleep(1)
      Table.Select(1)
      sleep(3)
     else
       warnlog "In first window the source  listbox is 0!"
       AutopilotTableElement.Cancel
    end if
   Kontext "AutopilotTableElement"
    if NextButton.IsEnabled then
       NextButton.Click
     else
       warnlog "In first window the 'Next'-button is disabled!"
       AutopilotTableElement.Cancel
    end if
    sleep(3)
    printlog "  - Autopilot Table Element: Page 2/2"
   Kontext "TabTableFieldSelection"
    call Dialogtest(TabTableFieldSelection)
    ExistingFields.Select(1)
    sleep(1)
    AddTo.Click
    sleep(3)
   Kontext "AutopilotTableElement"
    if CreateButton.IsEnabled then
       CreateButton.Click
     else
       warnlog "In fourth window the 'Create'-button is disabled!"
       AutopilotTableElement.Cancel
    end if
   else
    warnlog "- Autopilot for Table Element didn't appear!"
  end if
 sleep(2)
end sub

'-------------------------------------------------------------------------
sub sDeleteDatasource( sDSName )

 	dim ii as integer
	dim iNoDS as integer
	dim iRem as integer
	iRem = 0
'/// open TOOLS / DATASOURCE	
	Kontext "DataSourceAdministration"
	if not DataSourceAdministration.Exists(3) then 
		call hNewDocument
		ToolsDatasources
		sleep(1)
		iRem = 1
	endif
	
	Kontext "DataSourceAdministration"
	Kontext "DatabaseSourceList"
'/// search the datasource	
	iNoDS = DatabaseSourceList.getItemCount
	for ii = 1 to iNoDS
		DatabaseSourceList.select ii
		if DatabaseSourceList.getSelText = sDSName then
			ii = iNoDS
'/// use ENTF key to delete the datasource			
			DatabaseSourceList.TypeKeys "<DELETE>" , true
			sleep(1)
		end if
	next ii
'/// close the datasource admin dialog with OK		
	if iRem = 1 then 
		Kontext "DataSourceAdministration"
		DataSourceAdministration.OK
		call hCloseDocument
	endif
	sleep(1)
	
end sub

'-------------------------------------------------------------------------
function bCheckForDS(sDSName) as boolean
	dim iNoDS as integer
	dim i as integer
    'call hNewDocument
	bCheckForDS = FALSE
    'ToolsDataSources
    sleep(1)
	Kontext "DataSourceAdministration"
	Kontext "DatabaseSourceList"	
	iNoDS = DatabaseSourceList.getItemCount
	for i = 1 to iNoDS
		DatabaseSourceList.select i
		if DatabaseSourceList.getSelText = sDSName then
			i = iNoDS
			bCheckForDS = TRUE
		end if
	next i
	'DataSourceAdministration.OK
	sleep(1)
    'call hCloseDocument
end function
'--------------------------------------------------------------------
function fFindTable(sDSName1,sTableName1)
	dim i as integer
	dim bfindTable as boolean
	dim iNoDS as integer
    dim iNoTable as integer
    
    bfindTable = false
	Kontext "DatabaseBeamer"
    Kontext "DatabaseSelection"
		
    iNoDS = DatabaseSelection.getItemCount	
	for i = 1 to iNoDS
		DatabaseSelection.Select i
		if DatabaseSelection.getText = sDSName1 then
			i = iNoDS
		endif
	next i
	
    wait 500
	DatabaseSelection.TypeKeys "<ADD>" , true
    wait 500
	DatabaseSelection.TypeKeys "<DOWN>" , true
    wait 500
	DatabaseSelection.TypeKeys "<DOWN>" , true
    wait 500
	DatabaseSelection.TypeKeys "<DOWN>" , true
    wait 500
	DatabaseSelection.TypeKeys "<ADD>" , true
    wait 500
	DatabaseSelection.TypeKeys "<DOWN>" , true
    wait 500
	
	
    iNoTable = DatabaseSelection.getItemCount
    dim ii as integer
    ii = DatabaseSelection.GetSelIndex	
	for i = ii to iNoTable
		DatabaseSelection.Select i
		if DatabaseSelection.getText = sTableName1 then
			i = iNoTable
		    sleep 1			
		    bfindTable = true
		endif
	next i
	
    fFindTable = bfindTable
	
end function
'--------------------------------------------------------------------
function fFindDatasource(sDSName1)

	dim i as integer
	dim bfindDS as boolean
	dim iNoDS as integer    
    
    bfindDS = false
	Kontext "DatabaseBeamer"
    Kontext "DatabaseSelection"
		
    iNoDS = DatabaseSelection.getItemCount	
	for i = 1 to iNoDS
		DatabaseSelection.Select i
		if DatabaseSelection.getText = sDSName1 then
			i = iNoDS
            bfindDS = TRUE
		endif
	next i	
	
    fFindDatasource = bfindDS
	
    sleep(1)
    
end function
'--------------------------------------------------------------------
function fConnectToDatasource(sDSName , sPWD, optional bNewDoc)
    
    if ( isMissing (bNewDoc) )then
        bNewDoc = false
    endif
    
    if (bNewDoc) then
        call hNewDocument()
        ViewCurrentDatabase
    endif
    
    sleep(1)
    dim bConnect as boolean 
    bConnect = false
    if fFindDatasource(sDSName) = true then
        DatabaseSelection.TypeKeys "<ADD>"
        DatabaseSelection.TypeKeys "<DOWN>"
        DatabaseSelection.TypeKeys "<DOWN>"
        DatabaseSelection.TypeKeys "<DOWN>"
        DatabaseSelection.TypeKeys "<ADD>"                
        Kontext "LoginDialog"
            if LoginDialog.Exists(3) then
                Password.SetText sPWD
                LoginDialog.OK                
            end if
        bConnect = true    
    else
        warnlog "Could not found the datasource " + sDSName
    endif
    
    if (bNewDoc) then
        call hCloseDocument
    endif
    
    fConnectToDatasource = bConnect
    
end function
'--------------------------------------------------------------------
sub sDeleteTable( sDSName , sTabName )
	dim i as integer
	printlog "Delete the table " + sTabName + " in the database " + sDSName + "."
	try        
        call hNewDocument	
        
        ViewCurrentDatabase
        sleep(1)
        Kontext "DatabaseBeamer"
        Kontext "DatabaseSelection"
        dim iNoDS as integer
        iNoDS = DatabaseSelection.getItemCount	
        for i = 1 to iNoDS
            DatabaseSelection.Select i
            if DatabaseSelection.getText = sDSName then
                i = iNoDS
            endif
        next i
        DatabaseSelection.TypeKeys "<ADD>" , true
        wait (500)
        DatabaseSelection.TypeKeys "<DOWN>" , true
        wait (500)
        DatabaseSelection.TypeKeys "<DOWN>" , true
        wait (500)
        DatabaseSelection.TypeKeys "<DOWN>" , true
        wait (500)
        DatabaseSelection.TypeKeys "<ADD>" , true
        sleep (1)
        'Kontext "LoginDialog"
        'if LoginDialog.Exists then
        ' 	Password.setText "testuser"
        ' 	LoginDialog.OK
        'endif    
    
        Kontext "DatabaseBeamer"
        Kontext "DatabaseSelection"
        DatabaseSelection.TypeKeys "<DOWN>"
        iNoDS = DatabaseSelection.getItemCount
        dim iNoDS2 as integer
        iNoDS2 = DatabaseSelection.getSelIndex
        for i = iNoDS2 to iNoDS
            DatabaseSelection.Select i        
            if DatabaseSelection.getText = sTabName then
                i = iNoDS
                DatabaseSelection.TypeKeys "<DELETE>"
                sleep(1)
                Kontext "MessageBox"
                if MessageBox.Exists(3) then
                    if MessageBox.GetRT = 304 then
                        'printlog "304. Next click Yes"
                        Messagebox.Yes
                        'printlog "304. After click Yes"
                    else
                        'printlog "Not 304. Next click Yes"
                        MessageBox.Yes
                        'printlog "Not 304. After click Yes"
                    end if                
                endif
                sleep(1)
            endif
        next i
        sleep(1)
        call hCloseDocument
	catch
		warnlog "could not delete table"
	endcatch
end sub
'--------------------------------------------------------------------
function fSelectSchemaInDSA(sDSName,sSchema)
    
    dim bOK as boolean
    bOK = false
    
    dim iRem as integer
	iRem = 0
      	
	Kontext "DataSourceAdministration"
	if not DataSourceAdministration.Exists(3) then 
        '/// if TOOLS / DATASOURCE not open open it
        printlog "open TOOLS / DATASOURCE"	
        call hNewDocument
		ToolsDatasources
		sleep(1)
		iRem = 1
	endif
	
    Kontext "DataSourceAdministration"    
	    Kontext "DatabaseSourceList"
            DatabaseSourceList.select sDSName 'ii
            sleep(2)            
    
    Kontext "DataSourceAdministration"
		TabControl.setPage TabTables		
    Kontext "TabTables"        
        Selector.TypeKeys "<POS1>", true
        sleep(1)
        Selector.TypeKeys "<UP>", true
        sleep(1)
        Selector.TypeKeys "<SPACE>", true
        sleep(1)
        dim i as integer
        printlog "Selector.getItemCount = " + Selector.getItemCount
        for i = 1 to Selector.getItemCount            
            printlog "Selector.getSelText = " + Selector.getSelText
            if Selector.getSelText = sSchema then
                Selector.TypeKeys "<SPACE>", true
                sleep(1)
                i = Selector.getItemCount ' stop the loop
            endif
            Selector.TypeKeys "<DOWN>", true
         next
        sleep(1)
    if iRem = 1 then
        '/// close the datasource admin dialog with OK if the dialog wasn't allready open
        printlog "close the datasource admin dialog with OK if the dialog wasn't allready open"        
		Kontext "DataSourceAdministration"
		DataSourceAdministration.OK
		call hCloseDocument
	endif
	sleep(1)
    fSelectSchemaInDSA(sDSName,sSchema) = true
    
end function        
