'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: id_tools.inc,v $
'*
'*  $Revision: 1.6 $
'*
'*  last change: $Author: tbo $ $Date: 2003/09/11 13:44:54 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/*****************************************************************
'*
'* Owner : thorsten.bosbach@sun.com
'*
'* short description : some tools
'*
'******************************************************************
'*
' #1 hSetSpellHypLanguage
' #1 hFindSpellHypLanguage
' #1 GetDecimalSeperator
' #1 TBOrestart
' #1 StrToDouble
' #1 GetMeasUnit
' #1 LiberalMeasurement
'*
'\*****************************************************************

sub hSetSpellHypLanguage
'/// select a language with a dictionary, used for spellcheck, thesaurus and hyphenation ///'
    dim sTrieit as string
    
    ' only for asian languages i need to set the default language for the current document  to 'English(USA)'
    ' in all other languages the default has a dictionary
    if bAsianLan then
        '/// Tools->Options ///'
        ToolsOptions
        '/// select from section 'Language Settings' the item 'Languages' ///'
        hToolsOptions ("LANGUAGESETTINGS","LANGUAGES")
        '/// check checkbox 'For the current document only' in section 'Default languages for document' ///'
        AktuellesDokument.Check
        '/// If there is no Language defined in 'locale-file' (in same directory as this file is) be smart and select one that supports spellchecking ///'
        if (glLocale(4) = "") then
            Kontext "ExtrasOptionenDlg"
            '///+ cancel dialog 'Options - ' ///'
            ExtrasOptionenDlg.Cancel
            '///+ call the smart subroutine that tells you a valid language with an dictionary ///'
            sTrieit = hFindSpellHypLanguage
            '///+ Tools->Options ///'
            ToolsOptions
            '///+ select from section 'Language Settings' the item 'Languages' ///'
            hToolsOptions ("LANGUAGESETTINGS","LANGUAGES")
            '///+ check checkbox 'For the current document only' in section 'Default languages for document' ///'
            AktuellesDokument.Check
            '/// if smart routine found something, select it in section 'Default languages for document' listbox 'Western' ///'
            '///+ (manual users just select a language that has an icon in front of it ('ABC' with a checkmark) ///'
            if (sTrieit <> "") then
                Westlich.Select sTrieit
            else
                qaErrorLog "Sorry no spellbook found: id_tools.inc::hSetSpellHypLanguage"
            endif
        else
        '/// if a Language is already defined in the textfile ///'
            printlog glLocale (4)
            try
                '/// select it in section 'Default languages for document' listbox 'Western' ///'
                '///+ (manual users just select a language that has an icon in front of it ('ABC' with a checkmark) ///'
                Westlich.Select glLocale (4)
            catch
                warnlog "this language is not available: '" + glLocale (4) + "'"
            endcatch
        endif
        printlog "selected: '" + Westlich.GetSelText + "'"
        Kontext "ExtrasOptionenDlg"
        '///+ close dialog 'Options - ' with OK ///'
        ExtrasOptionenDlg.OK
    endif
end sub

function hFindSpellHypLanguage (optional sBooks()) as string
'/// print all available languages that have a 'language module' ///'
    dim iListLength as integer
    dim i as integer
    dim sTemp as string
    
    '/// only necessarry for asian languages ///'
    if bAsianLan then
        '/// Tools->Options ///'
        ToolsOptions
        '/// select from section 'Language Settings' the item 'Writing Aids' ///'
        hToolsOptions ("LANGUAGESETTINGS","WRITINGAIDS")
        '/// click button 'Edit...' in section 'Available language modules' ///'
        SprachmoduleBearbeiten.click
        kontext "ModuleBearbeiten"
        '/// print all entries from listbox 'Language' ///'
        for i = 1 to Sprache.GetItemCount
            sTemp = Sprache.GetItemText(i)
            if (NOT isMissing(sBooks())) then
                listAppend(sBooks(), sTemp)
            endif
            '/// return the first entry in the listbox ///'
            if i = 1 then hFindSpellHypLanguage = sTemp
        next i
        '/// close dialog 'Edit Modules' ///'
        ModuleBearbeiten.Close
        Kontext "ExtrasOptionenDlg"
        '/// close dialog 'Options - ' ///'
        ExtrasOptionenDlg.OK
        sleep 1
    endif
end function

function GetDecimalSeperator ( sDummy$ ) as String
'/// Input : number with fractionmark from 'NumericField' as String ///'
'///+ Output: '.' or ',' as String                                  ///'
   dim i1, i2 as integer

' get position of fraction mark / get IT
   i1 = instr (sDummy$, ",")
   i2 = instr (sDummy$, ".")
   if i1 > i2 then GetDecimalSeperator = "," else GetDecimalSeperator = "."
end function

sub TBOrestart
   hCloseDocument
   sleep (5)
  try  ' If Office has been exited ttool throws exception setting contect to msgbox (HDE)
   FileExit
   Kontext "Active"
   ' If first document has been modified, messagebox has to be closed
   if Active.Exists then
    if Active.GetRT = 304 then
     try
      Active.No
     catch
     endcatch
    endif
   endif
  catch
  endcatch
  sleep (30)   ' maybe checking if removed from task mgr ?
  Start sAppExe
   sleep (10)
   hNewDocument
   sleep (5)
end sub

function LiberalMeasurement ( sShould$, sActual$) as Boolean
'/// Input : (1. Should, 2. Actual) as Number with or without MeasurementUnit 'NumericField' as String ///'
'///+          if input has no MeasurementUnit i take it as 'cm' (was the default in old tests) ///'
'///+ Output: Boolean are they likely the same?
'/// NEEDED: mathematical proofment of iTolerance, by now just some guesses :-| ///'
'/// reason for this function:///'
'///+   because SO counts internaly in 'twip???s' 'twentieth of a point' there are some rounding errors ///'
'///+ there are also some rounding errors because of the internal representatio of floating point numbers in computers ///'
'///+   now lets try to get rid of them and have a nicer output in tests... ///'
'/// measurement units are defined in http://gsl.openoffice.org/source/browse/gsl/vcl/source/src/units.src ///'
   dim iTolerance as Double

   LiberalMeasurement = False ' worst case

' trivial
   if (sShould$ = sActual$) then
      LiberalMeasurement = True
   else
      ' check if measunit is the same !!
      if (GetMeasUnit(sShould$) <> GetMeasUnit(sActual$) ) then
         warnlog "In function LiberalMeasurement the measUnit is different, compare not possible yet"
      else
        ' set factor for liberality ;-)
        ' took units from http://gsl.openoffice.org/source/browse/gsl/vcl/source/src/units.src
         select case GetMeasUnit(sShould$)
            case "mm", "ミリ", "公厘" : iTolerance = 0.1             '01, 81,     88
            case "cm","センチ","厘米","公分"  : iTolerance = 0.04       '01, 81, 86, 88
            case chr$(34) : iTolerance = 0.02
            case "pi","ピクセル" : iTolerance = 0.01                 '01, 81
            case "pt",  "ポイント" : iTolerance = 0.1                '01, 81
            case "" : iTolerance = 0.03 ' cm is presubposition in old functions
         case else
            iTolerance = 0.1
            qaErrorLog "This Unit is not available in this function. '" + GetMeasUnit(sShould$) + "'"
         end select
         ' have to get the measurem unit, cause the offset is different for each :-(
         ' !!! val(str()) is important because of double calculating actions !!! #110996#
         if ( val(str(StrToDouble(sShould$)+iTolerance)) >= StrToDouble(sActual$) ) AND (val(str(StrToDouble ( sShould$ )-iTolerance)) <= StrToDouble ( sActual$ )) then
             LiberalMeasurement = True
         else
            LiberalMeasurement = False
            'printlog "LM: ---------------------------: "+sShould$ +":"+sActual$
         end if
         'printlog "### LibMeas: "+ (StrToDouble(sShould$) + iTolerance) +" - "+ StrToDouble(sShould$) +" - "+ (StrToDouble ( sShould$ ) - iTolerance)+" ; '"+GetMeasUnit(sShould$)+"'"
      end if
   end if
'      Printlog "+++++++++++++++++++++++++++++++++++++meas lib was here: "+LiberalMeasurement
end function

function GetMeasUnit ( sWert$ ) as String
    dim iBounder as integer
'/// Input : Number with or without MeasurementUnit 'NumericField' as String ///'
'///+ Output: Initials of MeasurementUnit as String or "" when only a number ///'

    iBounder = -1
    do
        inc iBounder
    loop until ( isNumeric(mid (sWert$, len(sWert$)-iBounder, 1)) OR (len(sWert$) <= (iBounder + 1)) )

   ' printlog right (sWert$, iBounder)
    if (len(sWert$) <= (iBounder + 1)) then
        if isNumeric(left (sWert$, 1)) then
            GetMeasUnit = right (sWert$, iBounder)
        else
            GetMeasUnit = sWert$
        endif
    else
        GetMeasUnit = right (sWert$, iBounder)
    endif
end function


function StrToDouble ( sWert$ ) as Double
  Dim sDummy$
  dim i, i1, i2 as integer
  dim a as integer
  dim b as integer
  dim c as double
  dim n as integer

'/// Input : {'a[. ,]b[mm cm " pi pt]' with a, b as integer} as String ///'
'///+ Output: a[. , ]b as double ///'

' get rid of measure unit, the only single character is '"' all others are two chars
' there was a problem, if there is NO meas.unit!!!
      if (isNumeric (sWert$) = FALSE) then
         if (  StrComp (right (sWert$, 1), chr$(34) ) = 0 ) then
            sDummy$ = Left ( sWert$, Len(sWert$)-1 )
         else
            sDummy$ = Left ( sWert$, Len(sWert$)-2 )
         endif
      else
         sDummy$ = sWert$
      endif
   ' get position of fraction mark
      i1 = instr (sDummy$, ",")  ' wrong output
      i2 = instr (sDummy$, ".")
      if i1 > i2 then i = i1 else i = i2
        ' in front of decimal seperator
         try
            a = val (left (sDummy$,i-1))
         catch
            'printlog sWert$ + ":" + sDummy$ + ":" + i + ":" + i1+ ":" + i2
         endcatch
      ' after the decimal seperator
         n = (len (sDummy$)-i)
         b = val (right (sDummy$, n) )
         c = b * 10 ^ -n
         'printlog "-------------- :"+sWert$ +" :'"+a+"' :"+n+" :"+b+" :'"+c+"':"
         ' !!! val(str()) is important because of double calculating actions !!! #110996#
         StrToDouble = val(str(a + c))
end function

sub hTBOtypeInDoc
   hRechteckErstellen ( 10, 10, 30, 40 )
end sub

