'*************************************************************************
'*
'*  $RCSfile: w_001a_.inc,v $
'*
'*  $Revision: 1.5 $
'*
'*  last change: $Author: hde $ $Date: 2003/06/27 09:06:33 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : helge.delfs@sun.com
'*
'* short description :
'*
'\***********************************************************************

sub w_001a_
    printLog Chr(13) + "--------- File Menu (w_001a_.inc) ----------"

    Call tFileProperties

    Call tFileTemplatesOrganize
    Call tFileTemplatesAddressbookSource
'   This has been disabled in Masterdocument until 6.1 Final
    if gApplication <> "MASTERDOC" then
        Call tFileTemplatesSave
    endif
    Call tFileTemplatesEdit

    Call tFilePagePreview
    Call tFilePrint
    Call tFilePrinterSetup

    if gApplication = "HTMLDOKUMENT" then
        Call tFileAutopilotWebPageLoadAll
    endif

'   Call tFileExit

end sub

'-----------------------------------------------------------

testcase tFileProperties
    PrintLog "- File / Properties"

    Call hNewDocument
    '/// Open new document ///

    FileProperties
    '/// File / Properties ///

    Sleep 5
    Kontext
    try
        active.SetPage TabDokument
    catch
        Warnlog "Dialog 'FileProperties' not up! (Bug#99828)"
        goto endsub
    endcatch


    Kontext "TabDokument"
    Call DialogTest (TabDokument)
    '/// Switch to Tabpage 'General' ///

    Kontext
    active.SetPage TabDokumentinfo
    Kontext "TabDokumentinfo"
    Call DialogTest (TabDokumentinfo)
    '/// Switch to Tabpage 'Description' ///

    Kontext
    active.SetPage TabBenutzer
    Kontext "TabBenutzer"
    Call DialogTest ( TabBenutzer )
    '/// Switch to Tabpage 'User defined' ///

    Wait 500
    Infofelder.Click
    '/// Click 'Infofields' ///
    Kontext "InfonamenBearbeiten"
    Call DialogTest (InfonamenBearbeiten)
    InfonamenBearbeiten.Cancel
    '/// Close upcoming dialog with 'Cancel' ///

    Kontext
    active.SetPage TabInternet
    Kontext "TabInternet"
    Call DialogTest (TabInternet)
    '/// Switch to Tabpage 'Internet' ///

    Kontext
    active.SetPage TabStatistik
    Kontext "TabStatistik"
    Call DialogTest (TabStatistik)
    TabStatistik.Close
    '/// Switch to Tabpage 'Statistics' and close dialog ///

    Sleep 1
    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tFileTemplatesOrganize
    Dim i as integer
    PrintLog "- File / Templates / Organize"

    Call hNewDocument
    '/// Open new document ///
    FileTemplatesOrganize
    '/// File / Templates / Organize ///
    Kontext "DVVerwalten"
    For i = 1 to 50
        if DVVerwalten.Exists then
            i = 51
        else
            Sleep 5
        endif
    next i
    if Not DVVerwalten.Exists then
        Warnlog "Dialog 'Template Management' not up !"
        Call hCloseDocument
        goto endsub
    endif
    wait 500
    ListeLinks.Select 1
    ListeLinks.TypeKeys "<Down><Up><Down>"
    '/// Select first entry in left list of dialog 'Template Management' ///
    Sleep 1
    Befehle.Click
    wait 500
    Call hMenuSelectNr(3)
    '/// Select 'Commands -> Import Template' ///
    Wait 500
    if gUseSysDlg = False then
        Kontext "OeffnenDlg"
        if OeffnenDlg.Exists then
            OeffnenDlg.Cancel
        else
            Warnlog "FileOpen dialog not up!"
        endif
    endif
    '/// Close Filedialog ///

    Kontext "DVVerwalten"
    Sleep 1
    Befehle.Click
    wait 500
    Call hMenuSelectNr(4)
    '/// Select 'Commands -> Printer Settings ///

    Kontext "DruckerEinrichten"
    if DruckerEinrichten.Exists then
        DruckerEinrichten.Cancel
    else
        Warnlog "Printersettings dialog is not up!"
    endif
    '/// Cancel 'Printer-Setup' dialog ///

    Kontext "DVVerwalten"
    ListeRechts.Select 1
    '/// Select first entry in right list ///

    '/// Select pushbutton 'File..' ///
    if WelcheDatei.IsEnabled then
        WelcheDatei.Click
        if gUseSysDlg = False then
            Kontext "OeffnenDlg"
            OeffnenDlg.Cancel
            '/// Cancel Filedialog ///
        endif
    endif

    Kontext "DVVerwalten"
    AddressBook.Click
    Kontext "AddressbookSource"
    '/// Select pushbutton 'Address Book' ///
    if AddressbookSource.Exists then
        AddressbookSource.Cancel
        '/// Cancel Dialog 'Address Book-Assignment' ///
    else
        Warnlog "Dialog ' Address Book Source' not up!"
    endif

    Kontext "DVVerwalten"
    DVVerwalten.Close
    '/// Close dialog ///

    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tFileTemplatesAddressbookSource
    printlog "- File / Templates / Address Book Source"
    Call hNewDocument
    '/// Open new document ///

    UseBindings
    '/// File / Templates /Address Book Source... ///
    FileTemplatesAddressbookSource

    Sleep 2
    Kontext "AddressbookSource"
    if AddressbookSource.Exists then
        Call DialogTest (AddressbookSource)
        '/// In 'Address Book Assignement' dialog click pushbutton 'Administrate' ///
        Administrate.Click
        Sleep 2
        '/// Close 'Data Source Administration' with 'Cancel' ///
        Kontext "DataSourceAdministration"
        if Not DataSourceAdministration.Exists then
            Warnlog "- Dialog 'Data Source Administration' not opened!"
            Kontext "AddressbookSource"
            AddressbookSource.Cancel
        else
            DataSourceAdministration.Cancel
            Kontext "AddressbookSource"
            AddressbookSource.Cancel
        endif
        '/// Close dialog ///
    else
        Warnlog "- Dialog Address Book Source not opened"
    endif

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tFileTemplatesSave
    printlog "- File / Templates / Save"
    Call hNewDocument
    '/// Open new document ///
    FileTemplatesSave
    '/// File / Templates / Save ///

    Kontext "DokumentVorlagen"
    Call DialogTest ( DokumentVorlagen )
    '/// On 'Templates' dialog click 'Organizer' ///

    Verwalten.Click
    Kontext "DVVerwalten"
    DVVerwalten.Close
    '/// Close dialog 'Template Management' ///

    Kontext "DokumentVorlagen"
    DokumentVorlagen.Cancel
    '/// Close 'Templates' dialog ///

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tFileTemplatesEdit
    printlog "- File / Templates / Edit"

    Call hNewDocument
    '/// Open new document ///
    FileTemplatesEdit
    '/// File / Templates / Edit ///

    if gUseSysDlg = False then
        Kontext "OeffnenDlg"
        OeffnenDlg.Cancel
    endif
    '/// Cancel Filedialog ///

    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tFilePagePreview
    PrintLog "- File / Page Preview"
    Dim gehtnicht as boolean
    gehtnicht = FALSE
    Select Case gApplication
        Case "WRITER"
            Call hNewDocument
            '/// Open new document ///

        Case "MASTERDOC"
            Call hNewDocument

        Case "HTMLDOKUMENT"
            printlog "Not in Writer/Web!"
            goto endsub
    end select

    Call wDokSchreiben("Just a small change!")
    '/// Enter some text in document ///
    FilePageView
    '/// File / Page Preview ///
    Sleep 1
    Kontext "DocPageViewWriter"
    if DocPageViewWriter.NotExists then
        Warnlog "Page Preview is not coming up!"
        Kontext "Active"
        if Active.Exists then
            if Active.GetRT = 304 then
                Active.No
            endif
        endif
    else
        if gehtnicht=FALSE then
            Kontext "OL_SW_Seitenansicht"
            if OL_SW_Seitenansicht.NotExists then
                Warnlog "Objectbar of Page Preview not visible!"
                FileClose
            else
                '/// Select 'Zoom 100%' in toolbar ///
                try
                    Massstab.Select 4
                catch
                    Warnlog "Unable to change Zoom factor in toolbar! (Bug#110498)"
                endcatch

                Kontext "OL_SW_Seitenansicht"
                DruckenSeitenansicht.Click
                '/// Click 'Print Page Preview' in toolbar ///
                Kontext "Active"
                if Active.Exists then
                    Warnlog "No default printer!"
                    Active.ok
                else
                    Kontext "DruckenDlg"
                    '/// Close 'Print' dialog with cancel ///
                    DruckenDlg.Cancel
                endif

                Kontext "OL_SW_Seitenansicht"
                '/// Click 'Print options page preview' in toolbar ///
                Skalierung.Click
                Kontext "DruckOptionen"
                Call DialogTest ( DruckOptionen )
                '/// Close 'Print Options' dialog with cancel ///
                DruckOptionen.Cancel

                Kontext "OL_SW_Seitenansicht"
                '/// Close Page Preview with button 'Close Preview' in toolbar ///
                SeitenansichtSchliessen.Click
            end if
        else
            Warnlog "Objectbar not addressable!"
        endif
    end if
    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tFilePrint
    PrintLog "- File / Print"

    Call hNewDocument
    '/// Open new document ///

    sleep 1
    '/// File / Print ///
    FilePrint

    Kontext "Active"
    Sleep 1
    if Active.Exists then
        if Active.GetRT = 304 then
            Active.Ok         ' Messagebox abfangen-> Kein Standarddrucker
            Warnlog "No Default Printer!"
        endif
    else
        '/// In printer dialog click 'Options' ///
        Kontext "DruckenDlg"
        Zusaetze.Click
        Sleep 1

        Kontext "DruckerZusaetzeWriter"
        Call DialogTest (DruckerZusaetzeWriter)
        DruckerZusaetzeWriter.Cancel
        '/// Close 'Prinre options' with 'Cancel' ///

        Kontext "DruckenDlg"
        if gPlatGroup = "unx" then
            Eigenschaften.Click
            '/// On Unix-Platforms select 'Properties ///
            Wait 500
            Kontext
            Active.Setpage TabDruckereinstellungenPapier
            Kontext "TabDruckereinstellungenPapier"
            Call DialogTest ( TabDruckereinstellungenPapier )

            Kontext
            Active.Setpage TabDruckereinstellungenGeraet
            Kontext "TabDruckereinstellungenGeraet"
            Call DialogTest ( TabDruckereinstellungenGeraet )

            TabDruckereinstellungenGeraet.Cancel
            '/// Cancel Printer Properties' (only unix) ///
        end if

        Kontext "DruckenDlg"
        Call DialogTest ( DruckenDlg )
        DruckenDlg.Cancel
        '/// Close 'Print' dialog ///
    endif

    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tFilePrinterSetup
    PrintLog "- File / Printer Setup"

    Call hNewDocument
    '/// Open new document ///

    Sleep 1
    '/// File / Printer Settings ///
    FilePrintersettings
    Kontext "Active"
    Sleep 1
    if Active.Exists then
        if Active.GetRT = 304 then
            Active.Ok         ' Messagebox abfangen-> Kein Standarddrucker
            Warnlog "No Default Printer!"
        endif
    else
        Kontext "DruckerEinrichten"
        Call DialogTest ( DruckerEinrichten )
        DruckerEinrichten.Cancel
        '/// Cancel 'Printer Setup' dialog ///
    endif
    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase tFileExit
    PrintLog "- File / Exit"
    Call wDokSchreiben("Hallo ich schließe mich gleich von ganz alleine")
    FileExit

    try
        Kontext "Active"
        if Active.Exists(1) then
            Active.No
        else
            Warnlog "Though a changed document is open, the office could be closed without a message!"
        end if
    catch
        Warnlog "Error on querying messagebox"
    endcatch

    Sleep 5
    Call hOfficeStarten

endcase

'-----------------------------------------------------------

testcase tFileAutopilotWebPageLoadAll
    Dim i as integer, j as integer
    Dim StartPilot as string, IstGeladen as boolean
    Dim LoadTime as integer, LoopCount as integer
    printlog "  * File Autopilot Web Page"
    'StartPilot = "macro:///WebWizard.HtmlAutoPilotBasic.Main"
    printlog "File / Autopilot / Web Page"
    '/// Only in HTML-Updatetest ///

    Call hNewDocument
    '/// Open new document ///

    Call ActivateAutoPilot("webpage")
    '/// File / Autopilot /Webpage... ///

    Kontext "Active"
    if Active.Exists then
        if Active.GetRT = 304 then
            try
                Active.No
            catch
                Warnlog Active.Gettext
                Warnlog "Open URL with Filedialog does not work! now Functionbar !"
                Active.OK
                wait 500
                Kontext "OeffnenDlg"
                OeffnenDlg.Cancel
                wait 500
                Kontext "Funktionsleiste"
                URLEingabe.SetText StartPilot
                URLEingabe.TypeKeys "<Return>"
                wait 500
            endcatch
        endif
    endif
    While IstGeladen = False
        While LoadTime < 60
            Kontext "AutoPilotWebPage"
            if AutopilotWebPage.Exists then
                IstGeladen = true
                printlog "Autopilot needs " + LoadTime + " seconds to load!"
                LoadTime = 60
            endif
            ' Maybe a messagebox comes up
            Kontext "Active"
            if Active.Exists then
                if Active.GetRT = 304 then
                    Warnlog Active.Gettext
                    Active.Cancel
                    goto endsub
                endif
            endif
            Sleep 1
            LoadTime = LoadTime + 1
            If LoadTime = 60 and IstGeladen = False then
                Warnlog "Autopilot has not been loaded after 1 Minute!"
                goto endsub
            endif
        Wend
    Wend

    Kontext "AutoPilotWebPage"
    '/// Insert all layout for every template ///
    for i = 1 to WebTemplate.GetItemCount
        WebTemplate.Select i
        printlog "- " & WebTemplate.GetSeltext
        Kontext "Active"
        if Active.Exists then
            if Active.GetRT = 304 then
                Warnlog Active.Gettext
                try
                    Active.No
                catch
                    Active.Ok
                endcatch
            endif
        endif
        Kontext "AutoPilotWebPage"
        while Layout.IsEnabled = false
            wait 500
        Wend
        for j = 1 to Layout.GetItemCount
            Layout.Select j
            printlog "-  " & Layout.GetSeltext
            Kontext "Active"
            if Active.Exists then
                if Active.GetRT = 304 then
                    Warnlog Active.Gettext
                        try
                            Active.No
                        catch
                            Active.Ok
                        endcatch
                endif
            endif
            Kontext "AutoPilotWebPage"
            while Layout.IsEnabled = False
                wait 500
            Wend
            if Scaled.IsEnabled and Scaled.IsChecked then
                if Tiled.IsEnabled then
                    Tiled.Check
                    Sleep 1
                    Scaled.Check
                endif
            else
                if Tiled.IsEnabled and Tiled.IsChecked then
                    if Scaled.IsEnabled then
                        Scaled.Check
                        Sleep 1
                        Tiled.Check
                    endif
                endif
            endif
            Sleep 1
        next j
        Sleep 1
    next i

    Cancel.Click
    Kontext "Active"
    if Active.Exists then
        if Active.GetRT = 304 then
            Warnlog Active.Gettext
            try
                Active.No
            catch
                Active.Ok
            endcatch
        endif
    endif
    ' The document will be unloaded when dialog is canceled!
    '/// Close documents ///
    if GetDocumentCount = 2 then
        Call hCloseDocument
    else
        if GetDocumentCount > 1 then
            Do until GetDocumentCount = 1
                Call hCloseDocument
                LoopCount = LoopCount  + 1
            Loop
            QAErrorLog LoopCount & " documents have been closed! (Bug#110456)"
        endif
    endif

endcase
