'*************************************************************************
'*
'*  $RCSfile: w_005_.inc,v $
'*
'*  $Revision: 1.1.1.1.2.1 $
'*
'*  last change: $Author: hde $ $Date: 2003/09/01 14:13:26 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************
'*                                                                **
'* owner : helge.delfs@sun.com                                    **
'*                                                                **
'* short description :                                            **
'*                                                                **
'\******************************************************************

sub w_005_
    printLog Chr(13) + "--------- Menu Format (w_005_.inc) ----------"

    Call tFormatDefault
    Call tFormatSections
    Call tFormatCharacter
    Call tFormatChangeCase
    Call tFormatRuby
    Call tFormatParagraph
    Call tFormatPage
    Call tFormatNumberingBullets
    Call tFormatStylesCatalog
    Call tFormatStylesLoad
    Call tFormatStylist
    Call tFormatAutoformatWhileTyping

end sub

'------------------------------------------------------

testcase tFormatDefault
    PrintLog "- Format / Default"

    Call hNewDocument
    '/// Open new document ///
    Call wBlindtextEinfuegen
    '/// Insert dummy text ///
    EditSelectAll
    '/// Edit / Select All ///
    FormatDefaultWriter
    '/// Format / Default ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'------------------------------------------------------

testcase tFormatSections
    printlog "- Format / Sections"
    Call hNewDocument
    '/// Open new document ///
    InsertSection
    '/// Insert / Section ///
    Kontext
    Active.Setpage TabBereiche
    Kontext "TabBereiche"
    '/// Step through all tabpages ///
    Bereichsliste.SetText "Mein Bereich"
    TabBereiche.OK
    sleep(5)
    FormatSections
    Kontext "BereicheBearbeiten"
    Call Dialogtest(BereicheBearbeiten)
    Optionen.Click
    sleep(2)
    Kontext
    Active.SetPage TabSpalten
    Kontext "TabSpalten"
    Call Dialogtest(TabSpalten)
    Kontext
    Active.SetPage TabHintergrund
    Kontext "TabHintergrund"
    Call DialogTest2(TabHintergrund, 1)
    Als.Select(2)
    Call DialogTest2 (TabHintergrund,2)
    Durchsuchen.Click
    sleep(2)
    Kontext
    If Active.Exists then
        if Active.GetRT = 304 then
            Warnlog Active.GetText
            Active.Ok
        endif
    end If
    Sleep 1
    Kontext "GrafikEinfuegenDlg"
    GrafikEinfuegenDlg.Cancel
    Sleep 1
    Kontext "TabHintergrund"
    TabHintergrund.Cancel
    sleep(1)
    Kontext "BereicheBearbeiten"
    BereicheBearbeiten.Cancel
    Call hCloseDocument
    '/// Close active document ///
endcase

'------------------------------------------------------

testcase tFormatCharacter
    PrintLog "- Format / Character"

    Call hNewDocument
    '/// Open new document ///

    FormatCharacter
    '/// Format / Character ///

    Kontext
    active.SetPage TabFont
    kontext "TabFont"
    Call DialogTest ( TabFont )
    '/// Step through all tabpages ///

    Kontext
    active.SetPage TabFontEffects
    kontext "TabFontEffects"
    Call DialogTest ( TabFontEffects )

    Kontext
    Active.SetPage TabFontPosition
    Kontext "TabFontPosition"
    Call DialogTest ( TabFontPosition )

    if gAsianSup = True then
        try
            Kontext
            Active.SetPage TabAsianLayout
            Kontext "TabAsianLayout"
            Call DialogTest ( TabAsianLayout )
        catch
            Warnlog "Tabpage 'Asian Layout' is not visible! Activated in Options ?"
        endcatch
    endif

    Kontext
    active.SetPage TabHyperlinkZeichen
    Kontext "TabHyperlinkZeichen"
    Call DialogTest ( TabHyperlinkZeichen )

    if gUSeSysDlg = False then
        Durchsuchen.Click
        Kontext "OeffnenDlg"
        if OeffnenDlg.Exists then
            OeffnenDlg.Cancel
        else
            Warnlog "File-Open dialog is not up!"
        endif
    endif

    Kontext "TabHyperlinkZeichen"
    Ereignisse.Click
    Kontext "MakroZuweisen"
    Call DialogTest ( MakroZuweisen )
    MakroZuweisen.Cancel

    Kontext
    active.SetPage TabHintergrund
    kontext "TabHintergrund"
    Call DialogTest ( TabHintergrund )
    '/// Close dialog ///
    TabHintergrund.Close

    Call hCloseDocument
    '/// Close active document ///

endcase

'------------------------------------------------

testcase tFormatChangeCase
    printlog "- Format / Change Case"
    Call hNewDocument
    '/// Open new document ///
    Call wDokSchreiben ("Hello World!")
    Call wDokSchreiben ("<Shift Home>")
    '/// Insert some text in document and select text ///

    Wait 500
    FormatChangeCaseUpper
    '/// Format / Case Characters / Upper ///
    Wait 500
    FormatChangeCaseLower
    '/// Format / Case Characters / Lower ///
    Wait 500
    if gAsianSup = True then
        try
            FormatChangeCaseHalfWidth
            '/// Format / Case Characters / Half Width ///
        catch
            Warnlog "Format / Change Case / Half Width does not work. Maybe no Asian support!"
        endcatch
        Wait 500
        try
            FormatChangeCaseFullWidth
            '/// Format / Case Characters / Full Width ///
        catch
            Warnlog "Format / Change Case / Full Width does not work. Maybe no Asian support!"
        endcatch
        Wait 500
        try
            FormatChangeCaseHiragana
            '/// Format / Case Characters / Hiragana ///
        catch
            Warnlog "Format / Change Case / Hiragana does not work. Maybe no Asian support!"
        endcatch
        Wait 500
        try
            FormatChangeCaseKatagana
        catch
            Warnlog "Format / Change Case / Katagana does not work. Maybe no Asian support!"
            '/// Format / Case Characters / Katagana ///
        endcatch
    endif

    Call hCloseDocument
    '/// Close active document ///
endcase

'------------------------------------------------

testcase tFormatRuby
    printlog "- Format / Ruby"
    if gAsianSup = True then
        if gApplication = "HTMLDOKUMENT" then
            printlog "Not in WriterWeb!"
            goto endsub
        endif
        Call hNewDocument
        '/// Open new document ///
        Call wDokSchreiben ("Hello World!")
        Call wDokSchreiben ("<Shift Home>")
        '/// Insert some text in document ///

        try
            FormatRuby
            '/// Format / Ruby ///
        catch
            Warnlog "Format / Ruby does not work. Maybe No Asian support!"
            Call hCloseDocument
            goto endsub
        endcatch
        Kontext "RubyDialog"
        Call DialogTest ( RubyDialog )

        '/// Open Stylist ///
        CallStylist.Click
        wait 500
        Kontext "Stylist"
        if Stylist.Exists then
            Stylist.close
        else
            Warnlog "Stylist has not been opened!"
        endif

        '/// Close Stylist and Ruby dialog ///
        Kontext "RubyDialog"
        DialogClose.Click

        Call hCloseDocument
        '/// Close active document ///
    endif
endcase

'------------------------------------------------

testcase tFormatParagraph
    PrintLog "- Format / Paragraph"

    Call hNewDocument
    '/// Open new document ///
    FormatParagraph

    '/// Format / Paragraph ///
    Kontext
    active.SetPage TabEinzuegeUndAbstaende
    kontext "TabEinzuegeUndAbstaende"
    Call DialogTest ( TabEinzuegeUndAbstaende )
    '/// Step through all tabpages ///

    Kontext
    Active.SetPage TabAusrichtungAbsatz
    Kontext "TabAusrichtungAbsatz"
    Call DialogTest ( TabAusrichtungAbsatz )

    Kontext
    active.SetPage TabNumerierungAbsatz
    kontext "TabNumerierungAbsatz"
    Call DialogTest ( TabNumerierungAbsatz )

    Kontext
    active.SetPage TabUmrandung
    kontext "TabUmrandung"
    Call DialogTest ( TabUmrandung )

    if gApplication <> "HTMLDOKUMENT" then
        Kontext
        active.SetPage TabTextfluss
        kontext "TabTextfluss"
        Call DialogTest ( TabTextfluss )

        if gAsianSup = True then
            try
                Kontext
                Active.SetPage TabAsianTypography
                Kontext "TabAsianTypography"
                Call DialogTest ( TabAsianTypography )
            catch
                Warnlog "Tabpage 'Asian Typography' is not visible! Activated in Options ?"
            endcatch
        endif

        Kontext
        active.SetPage TabTabulator
        kontext "TabTabulator"
        Call DialogTest ( TabTabulator )

        Kontext
        active.SetPage TabInitialen
        kontext "TabInitialen"
        Anzeigen.Check
        Call DialogTest ( TabInitialen )

        Kontext
        active.SetPage TabHintergrund
        Kontext "TabHintergrund"
        Call DialogTest2 ( TabHintergrund, 1 )
        Als.Select 2
        Kontext "TabHintergrund"
        Call DialogTest2 ( TabHintergrund, 2 )
        Durchsuchen.Click
        Kontext "GrafikEinfuegenDlg"
        GrafikEinfuegenDlg.Cancel

        kontext "TabHintergrund"
        TabHintergrund.Close
    else
        TabUmrandung.Close
    endif
    '/// Close dialog ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'------------------------------------------------

testcase tFormatPage
    PrintLog "- Format / Page"

    Call hNewDocument
    '/// Open new document ///

    FormatPageWriter
    '/// Format / Page ///

    Kontext
    '/// Step through all tabpages ///
    active.SetPage TabVerwalten
    kontext "TabVerwalten"
    Call DialogTest ( TabVerwalten )

    Kontext
    active.SetPage TabSeite
    kontext "TabSeite"
    Call DialogTest ( TabSeite )

    Kontext
    active.SetPage TabHintergrund
    Kontext "Active"
    If Active.GetRT = 304 then Active.Yes         ' Messagebox abfangen-> Seitenrnder auerhalb des Bereichs

    Kontext
    active.SetPage TabHintergrund
    kontext "TabHintergrund"
    Call DialogTest2 ( TabHintergrund, 1 )
    Als.Select 2
    Call DialogTest2 ( TabHintergrund, 2 )
    Durchsuchen.Click
    Sleep 2
    Kontext "GrafikEinfuegenDlg"
    GrafikEinfuegenDlg.Cancel

    Kontext
    active.SetPage TabKopfzeile
    kontext "TabKopfzeile"
    Call DialogTest ( TabKopfzeile )
    if gApplication <> "HTMLDOKUMENT" then
        KopfzeileMitAbstand.Check
        Zusaetze.Click

        Kontext
        active.SetPage TabUmrandung
        kontext "TabUmrandung"
        Call DialogTest ( TabUmrandung )
        Kontext
        active.SetPage TabHintergrund
        kontext "TabHintergrund"
        Call DialogTest ( TabHintergrund )
        Als.Select 2
        Call DialogTest ( TabHintergrund )
        TabHintergrund.Close
    endif
    Kontext
    active.SetPage TabFusszeile
    kontext "TabFusszeile"
    Call DialogTest ( TabFusszeile )
    if gApplication <> "HTMLDOKUMENT" then
        FusszeileMitAbstand.Check
        Zusaetze.Click

        Kontext
        active.SetPage TabUmrandung
        kontext "TabUmrandung"
        Call DialogTest ( TabUmrandung )
        Kontext
        active.SetPage TabHintergrund
        kontext "TabHintergrund"
        Call DialogTest2 ( TabHintergrund, 1 )
        Als.Select 2
        Call DialogTest2 ( TabHintergrund, 2 )
        TabHintergrund.Close

        Kontext
        active.SetPage TabUmrandung
        kontext "TabUmrandung"
        Call DialogTest ( TabUmrandung )

        Kontext
        active.SetPage TabSpalten
        kontext "TabSpalten"
        Call DialogTest ( TabSpalten )

        if gAsianSup = True then
            Kontext
            active.Setpage TabGrid
            Kontext "TabGrid"
            Call DialogTest ( TabGrid )
        endif

        Kontext
        active.SetPage TabFussnote
        kontext "TabFussnote"
        Call DialogTest ( TabFussnote )
        TabFussnote.Close
    else
        TabFussZeile.Close
    endif
    '/// Close dialog ///
    Call hCloseDocument
    '/// Close active document ///
endcase

'--------------------------------------------------

testcase tFormatNumberingBullets
    PrintLog "- Format / Numbering / Bullets"

    Call hNewDocument
    '/// Open new document ///
    FormatNumberingBullets
    '/// Format / Numbering/Bullets ///

    Sleep 5
    '/// Step through all tabpages ///
    Kontext
    Active.SetPage TabBullet
    Kontext "TabBullet"
    Call DialogTest ( TabBullet )

    Kontext
    Active.SetPage TabNumerierungsart
    Kontext "TabNumerierungsart"
    Call DialogTest ( TabNumerierungsart )

    Kontext
    Active.SetPage TabNumerierung
    Kontext "TabNumerierung"
    Call DialogTest ( TabNumerierung )

    Kontext
    Active.SetPage TabGrafiken
    Kontext "TabGrafiken"
    Call DialogTest ( TabGrafiken )

    Kontext
    Active.SetPage TabPositionNumerierung
    Kontext "TabPositionNumerierung"
    Call DialogTest ( TabPositionNumerierung )

    Kontext
    Active.SetPage TabOptionenNumerierung
    Kontext "TabOptionenNumerierung"
    Call DialogTest ( TabOptionenNumerierung )
    Numerierung.Select 9
    if gUseSysDlg = False then
        Auswahl.Click
        Sleep 5
        Call hMenuSelectNr (1)
        Sleep 5
        Kontext "OeffnenDlg"
        OeffnenDlg.Cancel
    endif
    Kontext "TabOptionenNumerierung"

    Sleep 1
'  MenuSelect(2)
'  Call hMenuSelectNr (3)
'  Sleep 10
    try
        Auswahl.Click
        Sleep 5
        Call hMenuSelectNr(2)
        Sleep 25
        Call hMenuClose
    catch
        Exceptlog
        Call hMenuClose
    endcatch

    TabOptionenNumerierung.Cancel
    '/// Close dialog ///

    Call hCloseDocument
    '/// Close active document ///
endcase

'--------------------------------------------------

testcase tFormatStylesCatalog
    PrintLog "- Format / Styles Catalog"

    Call hNewDocument
    '/// Open new document ///
    Sleep 3
    FormatStylesCatalog
    '/// Format / Styles Catalog ///
    Sleep 3
    Kontext "Vorlagenkatalog"
    Call DialogTest ( Vorlagenkatalog )
    '/// In Styles catalog click 'New' ///
    Neu.Click

    '/// Step through all tabpages ///
    Kontext
    active.SetPage TabVerwalten
    kontext "TabVerwalten"
    Call DialogTest ( TabVerwalten )

    Kontext
    active.SetPage TabEinzuegeUndAbstaende
    kontext "TabEinzuegeUndAbstaende"
    Call DialogTest ( TabEinzuegeUndAbstaende )

    Kontext
    Active.SetPage TabAusrichtungAbsatz
    Kontext "TabAusrichtungAbsatz"
    Call DialogTest ( TabAusrichtungAbsatz )

    Kontext
    active.SetPage TabFont
    kontext "TabFont"
    Call DialogTest ( TabFont )

    Kontext
    active.SetPage TabFontEffects
    kontext "TabFontEffects"
    Call DialogTest ( TabFontEffects )

    if gApplication <> "HTMLDOKUMENT" then
        Kontext
        active.SetPage TabTextfluss
        kontext "TabTextfluss"
        Call DialogTest ( TabTextfluss )

        Kontext
        active.SetPage TabBedingung
        kontext "TabBedingung"
        Call DialogTest ( TabBedingung )

        Kontext
        active.SetPage TabNumerierungAbsatz
        kontext "TabNumerierungAbsatz"
        Call DialogTest ( TabNumerierungAbsatz )

        Kontext
        active.SetPage TabTabulatoren
        kontext "TabTabulatoren"
        Call DialogTest ( TabTabulatoren )

        Kontext
        active.SetPage TabInitialen
        kontext "TabInitialen"
        Call DialogTest ( TabInitialen )

        Kontext
        active.SetPage TabHintergrund
        kontext "TabHintergrund"
        Call DialogTest2 ( TabHintergrund, 1 )
        FuerAbsatz.Select 2
        Sleep 1
        FuerAbsatz.Select 1
        Als.Select 2
        Call DialogTest2 ( TabHintergrund, 2 )
    endif

    Kontext
    active.SetPage TabUmrandung
    kontext "TabUmrandung"
    Call DialogTest ( TabUmrandung )
    TabUmrandung.Cancel

    Kontext "Vorlagenkatalog"
    Aendern.Click

    Kontext
    active.SetPage TabVerwalten
    kontext "TabVerwalten"
    Call DialogTest ( TabVerwalten )

    Kontext
    active.SetPage TabEinzuegeUndAbstaende
    kontext "TabEinzuegeUndAbstaende"
    Call DialogTest ( TabEinzuegeUndAbstaende )

    Kontext
    Active.SetPage TabAusrichtungAbsatz
    Kontext "TabAusrichtungAbsatz"
    Call DialogTest ( TabAusrichtungAbsatz )

    Kontext
    active.SetPage TabFont
    kontext "TabFont"
    Call DialogTest ( TabFont )

    Kontext
    active.SetPage TabFontEffects
    kontext "TabFontEffects"
    Call DialogTest ( TabFontEffects )

    if gApplication <> "HTMLDOKUMENT" then
         Kontext
        active.SetPage TabTextfluss
        kontext "TabTextfluss"
        Call DialogTest ( TabTextfluss )

        Kontext
        active.SetPage TabNumerierungAbsatz
        kontext "TabNumerierungAbsatz"
        Call DialogTest ( TabNumerierungAbsatz )

        Kontext
        active.SetPage TabTabulatoren
        kontext "TabTabulatoren"
        Call DialogTest ( TabTabulatoren )

        Kontext
        active.SetPage TabInitialen
        kontext "TabInitialen"
        Call DialogTest ( TabInitialen )

         Kontext
        active.SetPage TabHintergrund
        kontext "TabHintergrund"
        Call DialogTest2 ( TabHintergrund, 1 )
        FuerAbsatz.Select 2
        Sleep 1
        FuerAbsatz.Select 1
        Sleep 1
        Als.Select 2
        Call DialogTest2 ( TabHintergrund, 2 )
    endif

    Kontext
    active.SetPage TabFontPosition
    kontext "TabFontPostion"
    Call DialogTest ( TabFontPosition )

    Kontext
    active.SetPage TabUmrandung
    kontext "TabUmrandung"
    Call DialogTest ( TabUmrandung )
    TabUmrandung.Cancel
    '/// Close dialog ///

    Kontext "Vorlagenkatalog"
    Verwalten.Click
    Sleep 4
    '/// Close Styles Catalog ///
    Kontext "DVVerwalten"
    Call DialogTest ( DVVerwalten )
    DVVerwalten.Close

    Kontext "Vorlagenkatalog"
    Vorlagenkatalog.Close

    Call hCloseDocument
    '/// Close active document ///

endcase

'-------------------------------------------------------

testcase tFormatStylesLoad
    PrintLog "- Format / Styles / Load"
    Call hNewDocument
    '/// Open new document ///
    FormatStylesLoad
    '/// Format / Styles / Load ///
    Sleep 1
    Kontext "Neu"
    if Neu.Exists then
        Call DialogTest ( Neu )
        if gUseSysDlg = False then
            '/// In dialog 'Load File' click 'From File..' ///
            FromFile.Click
            Wait 500
            Kontext "OeffnenDlg"
            '/// Cancel upcoming File dialog ///
            if OeffnenDlg.Exists then
                OeffnenDlg.Cancel
            else
                Warnlog "File-Open-Dialog not up!"
            endif
        endif
        Kontext "Neu"
        if Neu.Exists then
            Warnlog "Dialog 'Load Templates' open!"
            Neu.Cancel
            '/// Close dialog 'Load document' ///
        endif
    else
        Warnlog "Dialog 'Load Templates' not up!"
    endif
    Call hCloseDocument
    '/// Close active document ///
endcase

'------------------------------------------------------

testcase tFormatStylist
    PrintLog "- Format / Stylist"

    Call hNewDocument
    '/// Open new document ///
    FormatStylist
    '/// Format / Stylist ///
    Kontext "Gestalter"
    Call DialogTest ( Gestalter )
    Zeichenvorlagen.Click
    '/// Click all Styles-buttons in Stylist ///
    if gApplication <> "HTMLDOKUMENT" then
        Sleep 1
        Rahmenvorlagen.Click
        Sleep 1
        Seitenvorlagen.Click
    endif
    Sleep 1
    Numerierungsvorlagen.Click
    Sleep 1
    Absatzvorlagen.Click
    Sleep 1

    TBGestalterRight.Click Giesskanne
    Sleep 1
    TBGestalterRight.Click Giesskanne
    Sleep 1

    TBGestalterRight.Click AusSelektion
    Sleep 1
    Kontext "VorlageErzeugen"
    DialogTest ( VorlageErzeugen )
    VorlageErzeugen.Cancel

    Kontext "Gestalter"
    Aktualisieren.Click
    Gestalter.Close
    '/// Close Stylist ///
    Call hCloseDocument
    '/// Close active document ///

endcase

'------------------------------------------------------

testcase tFormatAutoformatWhileTyping
    PrintLog "- Format / Autoformat / "

    Call hNewDocument
    '/// Open new document ///
    FormatAutoformatWhileTyping
    '/// Uncheck 'Format / Autoformat / While typing' ///
    wait 2000
    FormatAutoformatWhileTyping
    '/// Check 'Format / Autoformat / While typing' ///
    Call hCloseDocument
    '/// Close active document ///

endcase
